function set_font_matrix(ctx, matrix)
    ccall((:cairo_set_font_matrix, LIB_CAIRO), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, Ref(matrix))
end

function get_font_matrix(ctx)
    matrix = Cairo.CairoMatrix()
    ccall((:cairo_get_font_matrix, LIB_CAIRO), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, Ref(matrix))
    return matrix
end

function cairo_font_face_destroy(font_face)
    ccall(
        (:cairo_font_face_destroy, LIB_CAIRO),
        Cvoid, (Ptr{Cvoid},),
        font_face
    )
end

function set_ft_font(ctx, font)
    
    font_face = ccall(
        (:cairo_ft_font_face_create_for_ft_face, LIB_CAIRO),
        Ptr{Cvoid}, (AbstractPlotting.FreeTypeAbstraction.FT_Face, Cint),
        font, 0
    )

    ccall((:cairo_set_font_face, LIB_CAIRO), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, font_face)

    return font_face
end



"""
Finds a font that can represent the unicode character!
Returns AbstractPlotting.defaultfont() if not representable!
"""
function best_font(c::Char, font = AbstractPlotting.defaultfont())
    if AbstractPlotting.FreeType.FT_Get_Char_Index(font, c) == 0
        for afont in AbstractPlotting.alternativefonts()
            if AbstractPlotting.FreeType.FT_Get_Char_Index(afont, c) != 0
                return afont
            end
        end
        return AbstractPlotting.defaultfont()
    end
    return font
end
